/* IZ 050703

Make any object call any function(s) when a specific server has booted or has quit.
See ServerWatcher for more details. Examples: 

// Provide an action to be called when the local server calls:
1.onBoot({ |me| [me, "Ready for action"].postln; });
// Note: the third argument is the server to watch. Defaults to Server.local
// To respond to any other server, provide the server as third argument:
1.onBoot({ |me| [me, "Ready for action"].postln; }, Server.internal);

// Provide an action to be called when the local server quits: 
1.onQuit({ |me| [me, "bye bye"].postln; });

now try: 
Server.local.boot;
and then: 
Server.local.quit;

// To stop responding to server boots and quits: 
1.removeServer;


*/

+ Object {
	onBoot { | argAction, argServer |
		ServerWatcher.onBoot(this, argAction, argServer);
	}

	onQuit { | argAction, argServer |
		ServerWatcher.onQuit(this, argAction, argServer);
	}

	removeServer { | argServer |
		ServerWatcher.remove(this, argServer);
	}
}

+ Function {

	onBoot { | argServer |
		ServerWatcher.onBoot(this, this, argServer);
	}

	onQuit { | argServer |
		ServerWatcher.onQuit(this, this, argServer);
	}

}
