/* IZ August-September 2005

Pbracket marks the start and end of a pattern with a function

	Pbracket(pattern, begin, end):
evaluate begin function at the start of the pattern and the end function at its end. 

Examples: 

a = Pbracket(Pbind(\degree, Pwhite(0, 10, 15)), { |e| [\starting, e].postln; },{"stopped".postln;});
a.play(SystemClock, (dur: 0.1));

// NOTE: When playing a Ppar, the protoEvent provided as arg to .play must contain 
// define values either for delta or for both dur and stretch. 
(
b = 	Pseq([Ppar([a, Pbindf(a, \octave, 6)]), 
	Pbind(\dur, 1.5, \legato, 3, \degree, Pseq([\rest, Array.rand(8, 0, 10)]))]);
b.play(SystemClock, (dur: 0.15, stretch: 1, legato: 0.01));
)

/////////////
a = Pbracket(Pbind(\degree, Pwhite(0, 10, 15)), { |e| e[\octave] = 7; }, {"ended".postln});
a.play;

*/

Pbracket : FilterPattern {
	var <>begin, <>end;
	*new { arg pattern, begin, end;
		^super.new(pattern).begin_(begin).end_(end)
	}
	storeArgs { ^[pattern, begin, end] }
	embedInStream { arg event;
		var val, inEvent;
		var evtStream = pattern.asStream;
		// copying event prevents changes made by begin func from affecting other streams
		// but does not work with Pbind ?
//		begin.(event = event.copy);
		begin.(event);
		loop {
			inEvent = evtStream.next(event);
			if (inEvent.isNil) {
				end.(event);
				^event;
			};
			event = inEvent.yield;
		};
	}
}

/*

a = Pbracket(Pseq((1..5))).asStream;
{a.next} ! 7;




(
Pbracket(Pbind(\degree, Pwhite(0, 10, 15)), {|x|x.size.postln},{|x|x.keys.postln})
	.play(SystemClock, (dur: 0.1));
)

 
(
a = (dur: 0.5);
Ppar([
	Pbracket(Pbind(\degree, Pwhite(0, 10, 15)), 
		{|x|x[\legato] = 0.1},
		{|x|x.keys.postln}
	),
	Pbracket(Pbind(\degree, Pwhite(0, 10, 15)), 
		{|x|x[\legato] = 0.1},
		{|x|x.keys.postln}
	)
]).play(SystemClock, a);
)


	var <>begin, <>end;
	*new { arg pattern, begin, end;
		^super.new(pattern).begin_(begin).end_(end);
	}
	storeArgs { ^[pattern, begin, end] }

	embedInStream { arg event;
		var inevent;
		var stream = pattern.asStream;
		begin.(event);
		while { 
			(inevent = stream.next(event)).notNil; 
		}{
			
			["next one", inevent].postln;
			inevent.yield;
		};
		^end.(event);
	}
}
*/